package jalview.fts.api;

import jalview.fts.core.FTSRestRequest;
import jalview.fts.core.FTSRestResponse;

import java.util.Collection;

public interface FTSRestClientI
{

  public FTSRestResponse executeRequest(FTSRestRequest pdbRestRequest)
          throws Exception;

  public String getColumnDataConfigFile();

  public FTSDataColumnGroupI getDataColumnGroupById(String id)
          throws Exception;

  public FTSDataColumnI getDataColumnByNameOrCode(String nameOrCode)
          throws Exception;

  public int getPrimaryKeyColumIndex(
          Collection<FTSDataColumnI> wantedFields, boolean hasRefSeq)
          throws Exception;
          
  public FTSDataColumnI getPrimaryKeyColumn();

  public Collection<FTSDataColumnI> getAllDefaulDisplayedDataColumns();

  public Collection<FTSDataColumnI> getSearchableDataColumns();

  public Collection<FTSDataColumnI> getAllFTSDataColumns();
}

